#!/usr/bin/python

def start():

	m=12 #number of words to display
	scroll=0.7 #number of seconds which you have to press the button
	wait=1 #number of seconds wait before it starts scrolling through words
	repeat=3 #number of repeats of a set of words before moving up a layer
	pair=0

	#First pick 100  most probable words
	#Then pick m such that the cumulatve frequency between them decreases exponentially
	#Scroll through these m, long push == this word
	#Short push == move to next layer

	#Lather, rinse, repeat

	import maketables
	import dividewords
	import output

	import select
	import sys
	import termios
	import tty
	from termios import tcgetattr, tcsetattr
	import time
	import curses


	#Take options from command line.  The option you *want* are m, scroll, wait and repeat

	import sys, re
	for arg in sys.argv[1:]:
		if re.match(r'\w+=.*', arg):
			exec arg
		else:
			break

	old_termios = tcgetattr(0)

	try:
		tty.setcbreak(0)  #Put the terminal in raw mode but keep ^c==break

		sentance=[]
	
		wordlist = open ("dict")  #Read frequency table
		pairlist = open ("pairdict") #Read pair frequency table	

		notes = open("notes","a")

		count = {}
		layers={}
		paircount={}

		window=curses.initscr()

		if pair==1:
			window.addstr(42,0,'pairs on')

		maketables.innitial(wordlist,pairlist,paircount,count,pair,window)

		window.addstr(0,0,'****************************************************************************')	

		window.addstr(1,0,'This is a one button communication system.  Crawler will present you with a') 
		window.addstr(2,0,'list of words and some options for controlling it, to select any word or option') 
		window.addstr(3,0,'press any key on your keyboard while that word, or option, is highlighted.  The ')
		window.addstr(4,0,'word you have selected will then appear to the left of a new list of words, if ')
		window.addstr(5,0,'this was the word you wished to enter select it whilst it is highlighted.  If ')
		window.addstr(6,0,'the word you want is not in the list that you have select the first word that ')
		window.addstr(7,0,'is alphabetically after the word you want and then continue with the new list')
		window.addstr(8,0,'******************************************************************************')

		window.refresh()

		start=time.time()

		another=1
		presses=0 #count number of presses
		mistakes=0 #count number of errors including scrolling arround to go up
		mistakep=0 #number of presses that were mistakes or used to correct mistakes

		while another==1:
			words=count.keys()
			words.sort()

			layer=[0]
			savedwords=[]
			savedboundaries=[]			
			savedchosen=[]
			chosen="."
			chosenn=0	
			savedchosen.append([".",0])
			chosenn=0
			goneup=0

			while True:
				what,list,savedwords,presses,mistakes,another,chosen,chosenn,mistakep,\
				savedchosen,goneup,savedboundaries=\
				dividewords.dividewords(words,count,sentance,m,paircount,scroll,wait,\
				layer,savedwords,repeat,presses,mistakes,window,pair,chosen,chosenn,\
				mistakep,layers,savedchosen,goneup,savedboundaries)

				if what=="sentance":
					sentance=list			
		
					window.addstr(10,0,"current sentence is:")
					string=""
					for word in sentance:
						string=string+ word+ " "					
					window.addstr(11,0,"                                                                                                                                                                                                      ")
					window.addstr(11,0,string)
					window.refresh()
					break
				if what=="words":
					words=list
			
		window.clear()
		window.addstr(0,0, 'you have entered')
		thing=""
		for word in sentance:
			thing=thing+word+" "
		window.addstr(1,0,thing)
		window.addstr(2,0,"")
		window.refresh()

		end=time.time()

		output.output(start,end,presses,sentance,mistakes,scroll,pair,mistakep,layers,count)

	finally: #Really, we want this to run.  Really really really.  Or it's BAD.
		tcsetattr(0, termios.TCSAFLUSH, old_termios)

start()
